void load_images(void){
int n1,n;
FILE *imagefile;
char filename[160];
puts("Loading images:");

for(n1=0;n1<EXPLOSIONS;n1++)
{
sprintf(filename,"%s/graphics/explosion%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(explosions[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
explosions[n1].bitmap[n]=explosions[n1].mask[n]?explosions[n1].bitmap[n]:0x00;

}
;
}
for(n1=0;n1<ALIENS;n1++)
{
sprintf(filename,"%s/graphics/alien%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(aliens[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
aliens[n1].bitmap[n]=aliens[n1].mask[n]?aliens[n1].bitmap[n]:0x00;

}
;
}
for(n1=0;n1<FIGHTERS;n1++)
{
sprintf(filename,"%s/graphics/fighter%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(fighters[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
fighters[n1].bitmap[n]=fighters[n1].mask[n]?fighters[n1].bitmap[n]:0x00; 

}
;
}
/*
for(n1=0;n1<HYPERSPACES;n1++)
{
sprintf(filename,"%s/graphics/hyperspace%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(hyperspaces[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
hyperspaces[n1].bitmap[n]=hyperspaces[n1].mask[n]?hyperspaces[n1].bitmap[n]:0x00;

}
;
}*/
for(n1=0;n1<TRANSS;n1++)
{
sprintf(filename,"%s/graphics/trans%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(transs[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
transs[n1].bitmap[n]=transs[n1].mask[n]?transs[n1].bitmap[n]:0x00;

}
;
}
for(n1=0;n1<SHELTERS;n1++)
{
sprintf(filename,"%s/graphics/shelter%d",DIR,n1);
if((imagefile=fopen(filename,"rb"))==NULL){
printf("Cannot open %s\n",filename);
exit(0);
}else
{
fread(shelters[n1].bitmap,512,1,imagefile);
fclose(imagefile);

for(n=0;n<256;n++)
shelters[n1].bitmap[n]=shelters[n1].mask[n]?shelters[n1].bitmap[n]:0x00;

}
;
}

}


void reload_level(){
int n;

mouse_setposition(160,160);
Me_x=Me_y=160;
FPS=30;
waitcycle=10000;
GeneralFrameCounter=0;
palettecounter=16;
loadlevel(LEVEL);
level_height=0;
for(n=0;n<MAXFIRES;n++)fire[n].y=-3.;
for(n=0;n<MAXALIENFIRES;n++)alienfire[n].y=-3.;
bodycount=0;
me_hitted=NO;

}


void paint_sprite(struct imagetype *ptr,int phase,int x,int y,unsigned char hit){
unsigned char _old [256];

#ifdef FAST_COMPUTER
unsigned char _new [256];
#endif

int n;
gl_getbox(x,y,16,16,_old);
n=0;

#ifndef FAST_COMPUTER
gl_putboxmask(x,y,16,16,ptr[phase].bitmap);
#else
while(n<256){
_new[n]=ptr[phase].mask[n]?ptr[phase].bitmap[n]:_old[n];
n++;
};
gl_putbox(x,y,16,16,_new);
#endif

}


void draw_screen(void){
char bottom_line[50];
int x,y;
draw_again:
gl_setcontext(background);
gl_copyscreen(backscreen);
gl_setcontext(backscreen);
sprintf(bottom_line,"SCORE:%06d LEVEL:%02d LIVES:%01d SHLDS:%03d%%",
SCORE,LEVEL,LIVES,SHIELDS);
gl_setwritemode(WRITEMODE_OVERWRITE);
gl_write(0,191,bottom_line);

/*my guns*/
if(leftcounter>0)leftcounter--;
if(midcounter>0)midcounter--;
if(rightcounter>0)rightcounter--;
for(x=0;x<MAXFIRES;x++)
if(fire[x].y>-2)
gl_line((int)fire[x].x,(int)fire[x].y,(int)fire[x].x,(int)fire[x].y-5,15);


/*alien guns*/
for(x=0;x<MAXALIENFIRES;x++)
if(alienfire[x].y>-2){
gl_setpixel((int)alienfire[x].x,(int)alienfire[x].y,alienfire[x].colour);
gl_setpixel((int)alienfire[x].x,(int)alienfire[x].y+1,alienfire[x].colour);
}

/*my fighter*/

if(SHIELDS>0){paint_sprite(fighters,MyPhase,Me_x,Me_y,me_hitted);
MyPhase=1-MyPhase;}
else 
{
if(bodycount==0){Last_x=Me_x;Last_y=Me_y;};
paint_sprite(explosions,bodycount/6,Last_x,Last_y,NO);
bodycount++;
if(bodycount>(EXPLOSIONS*6)){
LIVES--;
if(LIVES<0)LIVES=0;
bodycount=0;
SHIELDS=100;
reload_level();
goto draw_again;
};
}
/*level title*/
if(level_height<192){
gl_write((20-strlen(LevelTitle)/2)*8,192-level_height,LevelTitle);
level_height++;
}


/*shelters*/
for(x=0;x<no_of_shelters;x++){
y=2-(3*Shelter[x].counter-1)/(35*Shelter[x].type+70);
if(Shelter[x].counter>0)
paint_sprite(shelters,Shelter[x].type*3+y,
(int)Shelter[x].x,(int)Shelter[x].y,Shelter[x].hitted);
}
/*now the hyperspace entry (disabled);
paint_sprite(hyperspaces,hsph/hsfreq,hsx,hsy);
if(hsdir==1){
hsph--;if(hsph==-1)hsph=HYPERSPACES*hsfreq-1;
}
else 
{
hsph++;if(hsph==(HYPERSPACES*hsfreq))hsph=0;};
*/
/*and now something completely different: alien ships*/
for(x=0;x<enemies;x++)
switch(XX[x].status){
case ALIVE:
paint_sprite(aliens,XX[x].alientype,(int)XX[x].x,(int)XX[x].y,XX[x].hitted);break;

case EXPLODING:
paint_sprite(explosions,XX[x].counter/FRAMESPEREXPLOSION,(int)XX[x].x,(int)XX[x].y,NO);
XX[x].counter++;
if(XX[x].counter>=(EXPLOSIONS*FRAMESPEREXPLOSION))XX[x].status=DESTROYED;
break;

case TRANSMITTED:
paint_sprite(transs,XX[x].counter/FRAMESPERTRANSMISSION,(int)XX[x].x,(int)XX[x].y,NO);
XX[x].counter++;
if(XX[x].counter>=(TRANSS*FRAMESPERTRANSMISSION))XX[x].status=ALIVE;
break;

default:break;};


gl_copyscreen(physicalscreen);
}


void addfire(int x,int y){
int n;
if(SHIELDS<=0)return;
for(n=0;n<MAXFIRES;n++)
if(fire[n].y<-2){
fire[n].x=(float)x;
fire[n].y=(float)y;
NO_OF_FIRES++;
return;
}
}


void alienaddfire(float x,float y,int colour){
int n;
for(n=0;n<MAXALIENFIRES;n++)
if(alienfire[n].y<-2){
alienfire[n].x=x;
alienfire[n].y=y;
alienfire[n].colour=colour;
goto fin;
}
fin:
}

void alienFIRE(int num){
float x,y;
int n;
x=XX[num].x;y=XX[num].y;
for(n=0;n<alienguns[(XX[num].alientype)].howmany;n++)
alienaddfire(x+alienguns[(XX[num].alientype)].offset[n].x,
y+alienguns[(XX[num].alientype)].offset[n].y,
alienguns[(XX[num].alientype)].colour);


}

void mouse_job(void){
int n1,n2;


for(n1=0;n1<MAXFIRES;n1++){
if(fire[n1].y>5){
fire[n1].y-=150./(float)FPS;
}
else fire[n1].y=-3;
}

/*but enemy must fire too*/
for(n1=0;n1<MAXALIENFIRES;n1++){
n2=alienfire[n1].colour;
if(alienfire[n1].y<-2)goto next;
if(alienfire[n1].y<190)alienfire[n1].y+=5.*((float)n2-7.)/(float)FPS;
else alienfire[n1].y=-3;
next:
}

if(mouse_update()==1){
Me_x=mouse_getx();
Me_y=mouse_gety();}
m_button=mouse_getbutton();

/*my super tripple fire:*/ 

if((m_button&MOUSE_LEFTBUTTON)==MOUSE_LEFTBUTTON)

if(leftcounter==0){
addfire(Me_x+1,Me_y+5);
leftcounter=FRAMESPERFIRE;
}

if((m_button&MOUSE_RIGHTBUTTON)==MOUSE_RIGHTBUTTON)
if(rightcounter==0){
addfire(Me_x+13,Me_y+5);
rightcounter=FRAMESPERFIRE;
}

if((m_button&MOUSE_MIDDLEBUTTON)==MOUSE_MIDDLEBUTTON)
if(midcounter==0){
addfire(Me_x+7,Me_y-2);
midcounter=FRAMESPERFIRE;
}

if((m_button&(MOUSE_LEFTBUTTON+MOUSE_RIGHTBUTTON))==(MOUSE_LEFTBUTTON+MOUSE_RIGHTBUTTON))
if(midcounter==0)
{
addfire(Me_x+7,Me_y-2);
midcounter=FRAMESPERFIRE;
}

}


void test_collision(void){
int n,z;

for(z=0;z<enemies;z++){
XX[z].hitted=NO;
for(n=0;n<MAXFIRES;n++)
if(XX[z].status==ALIVE)
if((fire[n].x<(XX[z].x+15))&&(fire[n].x>=XX[z].x))
if((fire[n].y>XX[z].y)&&(fire[n].y<(XX[z].y+15))){
XX[z].shields--;
XX[z].hitted=YES;
NO_OF_HITS++;
if(XX[z].shields<=0){
XX[z].status=EXPLODING;
XX[z].counter=0;
switch(XX[z].alientype){
case 0:SCORE+=20;break;
case 1:SCORE+=150;break;
case 2:SCORE+=70;break;
case 3:SCORE+=50;break;
case 4:SCORE+=50;break;
case 5:SCORE+=50;break;
case 6:SCORE+=70;break;
case 7:SCORE+=100;break;
case 8:SCORE+=50;break;
case 9:SCORE+=200;break;
default:break;
}}
fire[n].y=-3;
goto next_one;
};

next_one:
;
};

}

int have_I_got_it(void){
int n,x,y;
me_hitted=NO;
if(SHIELDS!=0)
for(n=0;n<MAXALIENFIRES;n++)
{
x=(int)alienfire[n].x;
y=(int)alienfire[n].y;
if((y>=Me_y)&&(y<(Me_y+15))&&(x<(Me_x+14))&&(x>Me_x)){
alienfire[n].y=-3;
SHIELDS-=TOUGHNESS;
if(SHIELDS<=0){
SHIELDS=0;
me_hitted=YES;
return YES;};
};
}
else return YES;
return NO;
}

void everything_moves(void){
int q;

for(q=0;q<enemies;q++)
if(XX[q].status==ALIVE)
{
switch(XX[q].movement){
case NONE:goto next_one;
case CHAOTIC:
 XX[q].vx=random()/(RAND_MAX/61)-30;
 XX[q].vy=random()/(RAND_MAX/61)-30;

/*no 'break' here!!*/

case LINEAR:
 XX[q].x+=((float)XX[q].vx)/((float)FPS);
 XX[q].y+=((float)XX[q].vy)/((float)FPS);
 break;
 default:break;
};
 
if(XX[q].x<0.)  {XX[q].x=0.;  XX[q].vx= -XX[q].vx;};
if(XX[q].y<0.)  {XX[q].y=0.;  XX[q].vy= -XX[q].vy;};
if(XX[q].x>303.){XX[q].x=303.;XX[q].vx= -XX[q].vx;};
if(XX[q].y>106.){XX[q].y=106.;XX[q].vy= -XX[q].vy;};
next_one:
};

for(q=0;q<no_of_shelters;q++)
if(Shelter[q].counter>0)
{
switch(Shelter[q].movement){
case NONE:goto next_one2;

case CHAOTIC:
Shelter[q].vx=(random()/(RAND_MAX/61)-30);
Shelter[q].vy=(random()/(RAND_MAX/61)-30);

/*no 'break' here!!*/

case LINEAR:
Shelter[q].x+=((float)Shelter[q].vx)/(float)FPS;
Shelter[q].y+=((float)Shelter[q].vy)/(float)FPS;
 break;
 default:break;
};
 
if(Shelter[q].x<0.)  {Shelter[q].x=0.;  Shelter[q].vx= -Shelter[q].vx;};
if(Shelter[q].y<122.)  {Shelter[q].y=122.;  Shelter[q].vy= -Shelter[q].vy;};
if(Shelter[q].x>303.){Shelter[q].x=303.;Shelter[q].vx= -Shelter[q].vx;};
if(Shelter[q].y>176.){Shelter[q].y=176.;Shelter[q].vy= -Shelter[q].vy;};
next_one2:
};

}

void shelters_job(void){
int q,n,x,y,Sx,Sy;
if(no_of_shelters==0)return;
for(q=0;q<no_of_shelters;q++)
if(Shelter[q].counter>0){
Sx=Shelter[q].x;
Sy=Shelter[q].y;
Shelter[q].hitted=NO;
for(n=0;n<MAXALIENFIRES;n++){
x=alienfire[n].x;
y=alienfire[n].y;
if((y>=Sy)&&(y<(Sy+15))&&(x<=(Sx+15))&&(x>=Sx)){
alienfire[n].y=-3;
Shelter[q].counter--;
Shelter[q].hitted=YES;}
}
};
}

void framespeed(void){
int diff;
currclock=clock();
diff=currclock-lastclock;
FPS=(11*100)/diff;
lastclock=clock();
GeneralFrameCounter=0;

#ifdef IN_DEVEL
printf("Rate:%d frames per second\n",FPS);
#endif
}

int results(void){
int place=0,n2,n3;
char string[160];
vga_clear();
gl_setcontext(physicalscreen);
if(picture!=NULL)free(picture);
palettecounter=16;
sprintf(string,"%s/pics/finalresults.pcx",DIR);
picture=loadPCX(string);
for(n2=16;n2<256;n2++)gl_setpalettecolor(n2,0,0,0);
gl_putbox(0,0,320,200,picture);
for(n2=0;n2<64;n2++){
for(n3=16;n3<256;n3++)
gl_setpalettecolor(n3,(pal[n3-16].R*n2)/63,(pal[n3-16].G*n2)/63,(pal[n3-16].B*n2)/63);
usleep(5000);
};

if(NO_OF_HITS==0){
gl_write(24,46,"OH NO! Death without a fight.");
gl_write(24,54,"That's very bad, man.");
goto mousei;
}
sprintf(string,"Score:%07d",SCORE);
gl_write(24,46,string);
sprintf(string,"You fired %d times",NO_OF_FIRES);
gl_write(24,56,string);
sprintf(string,"Enemy robots hitted %d times",NO_OF_HITS);
gl_write(24,66,string);
FIRE_EFFICIENCY=(100*NO_OF_HITS)/NO_OF_FIRES;
sprintf(string,"Fire efficiency: %d %%",FIRE_EFFICIENCY);
gl_write(24,76,string);
n3=(SCORE*FIRE_EFFICIENCY)/100;
sprintf(string,"-> Total score = %07d",n3);
gl_write(24,96,string);

if((resultfile=fopen("./HiScores","rb"))==NULL)
for(n2=0;n2<10;n2++){
scoretable[n2].score=7000+(9-n2)*2000;
scoretable[n2].efficiency=50;
scoretable[n2].level=n2*10+9;
sprintf(scoretable[n2].name,"P.V.C.");
}
else {
fread(scoretable,sizeof(struct _Score),10,resultfile);

fclose(resultfile);};

place= -1;

for(n2=0;n2<10;n2++){
if((n3==scoretable[n2].score)&&(FIRE_EFFICIENCY>=scoretable[n2].efficiency)){
place=n2+1;
goto placefound;
};
if(n3>scoretable[n2].score){
place=n2+1;
goto placefound;
};
}
placefound:
switch(place){
case -1:gl_write(24,106,"but you're not in hall of fame");break;
case 1:gl_write(24,106,"YES! You're FIRST in hall of fame");break;
case 2:gl_write(24,106,"GOOD! You placed SECOND.");break;
case 3:gl_write(24,106,"Not bad! You placed THIRD.");break;
default:
sprintf(string,"You placed %dth in the hall of fame",place);
gl_write(24,106,string);
}

mousei:
gl_write(24,167,"     Press any mouse button");
mouse_waitforupdate();
for(;(n2=mouse_getbutton())==0;)mouse_waitforupdate();
gl_fillbox(24,46,294-24,175-46,0);

if(place!=-1){cuserid(string);
if(strlen(string)>11)string[11]='\0';
if(place<10)for(n2=8;n2>=(place-1);n2--)scoretable[n2+1]=scoretable[n2];
sprintf(scoretable[place-1].name,"%s",string);
scoretable[place-1].efficiency=FIRE_EFFICIENCY;
scoretable[place-1].score=n3;
};

gl_write(24,46,"      H a l l  o f  f a m e");
gl_write(24,56,"No.  user     fire-eff.     score  "); 
for(n2=0;n2<10;n2++){
sprintf(string,"%d",n2+1);
gl_write(24,66+n2*10,string);
gl_write(65,66+n2*10,scoretable[n2].name);
sprintf(string,"%d %%",scoretable[n2].efficiency);
gl_write(128+strlen(string)*8,66+n2*10,string);
sprintf(string,"%07d",scoretable[n2].score);
gl_write(242,66+n2*10,string);
}

gl_write(24,174,"Left button=start again,right=exit");

if((resultfile=fopen("./HiScores","wb"))==NULL)puts("Cannot save High Scores table ! (file HiScores)");
else {
fwrite(scoretable,sizeof(struct _Score),10,resultfile);
fclose(resultfile);
}
mouse_waitforupdate();
cti_mys:

for(;(n2=mouse_getbutton())==0;){
repete:
if(place!=-1){
usleep(200000);
sprintf(string,"%d",place);
gl_write(24,66+(place-1)*10,string);
gl_write(65,66+(place-1)*10,scoretable[place-1].name);
sprintf(string,"%d %%",scoretable[place-1].efficiency);
gl_write(128+strlen(string)*8,66+(place-1)*10,string);
sprintf(string,"%07d",scoretable[place-1].score);
gl_write(242,66+(place-1)*10,string);
usleep(200000);
gl_write(24,66+(place-1)*10,"                                   "); };

if(mouse_update()==0)goto repete;
}
if(n2==MOUSE_RIGHTBUTTON)return 0;
if(n2==MOUSE_LEFTBUTTON)return 1;
goto cti_mys;
}